public class BSP {

   private vor koren;

   // Konstruktor
   public BSP() {

      koren = null;
   }

   /**************** Operacija nalaenja vora ****************/

   // Nalaenje vora sa kljuem k
   public vor nai(int k) {

      vor v = koren;
      while (v != null)
         if (k < v.klju)
            v = v.levo;
         else if (k > v.klju)
            v = v.desno;
         else // v je vor sa kljuem k
            break;
      return v;
   }

   /**************** Operacija dodavanja vora ****************/

   // Dodavanje vora sa kljuem k
   public void dodaj(int k) {

      if (koren == null)
         koren = new vor(k);
      else {
         vor v = koren;
         while (true)
            if (k < v.klju)
               if (v.levo == null) {
                  v.levo = new vor(k);
                  break;
               }
               else
                  v = v.levo;
            else if (k > v.klju)
               if (v.desno == null) {
                  v.desno = new vor(k);
                  break;
               }
               else
                  v = v.desno;
            else // duplikat
               break;
      }
   }

   /**************** Operacija uklanjanja vora ****************/

   // Uklanjanje vora v
   private vor ukloni(vor v) {

      if (v.levo != null && v.desno != null) { // v ima dvoje dece
         vor w = v.desno; // w je najmanji vor u desnom podstablu od v
         vor u = null;    // u je roditelj najmanjeg vora w
         // Nalaenje najmanjeg vora u desnom podstablu vora v
         while (w.levo != null) {
            u = w;
            w = w.levo;
         }
         // Zamenjivanje kljua vora v kljuem najmanjeg vora w
         v.klju = w.klju;
         // Uklanjanje najmanjeg vora w u desnom podstablu vora v
         if (u == null)  // v je roditelj od w
            v.desno = w.desno;
         else
            u.levo = w.desno;
      }
      else  // v ima najvie jedno dete
         if (v.levo != null )
            v = v.levo;
         else
            v = v.desno;
      return v;
   }

   // Uklanjanje vora sa kljuem k
   public void ukloni(int k) {

      vor v = koren;
      while (v != null) {
         if (k < v.klju)
            if (v.levo != null && v.levo.klju == k)
               v.levo = ukloni(v.levo);
            else
               v = v.levo;
         else if (k == v.klju) {
            koren = ukloni(v);
            break;
         }
         else // k > v.klju
            if (v.desno != null && v.desno.klju == k)
               v.desno = ukloni(v.desno);
            else
               v = v.desno;
      }
   }

   /************** Operacija prikazivanja stabla **************/

   // Prikazivanje stabla na ekranu
   public void prikai() {
     if(koren == null )
        System.out.println("Prazno stablo");
     else
        prikai(koren);
   }
   private void prikai(vor v) {
      if (v != null) {
          prikai(v.levo);
          v.prikai();
          prikai(v.desno);
      }
   }

   /*************** Reprezentacija jednog vora ***************/

   // Unutranja klasa za vor stabla
   private class vor {

      private int  klju;  // Comparable
      private vor levo;
      private vor desno;

      // Konstruktor
      public vor(int klju) {
         this.klju = klju;
         this.levo = null;
         this.desno = null;
      }

      // Prikazivanje kljua vora
      private void prikai() {
         System.out.println(klju);
      }
   }
}