// ,,Klijentska klasa'' za testiranje
public class TestPovezanaLista {

   public static void main(String[] args) {

      // Konstruisanje prazne liste
      PovezanaLista lista = new PovezanaLista();

      // Dodavanje nekih elemenata u listu
      int k = 17;
      lista.dodaj(k);
      lista.dodaj(23); lista.dodaj(31); lista.dodaj(47);
      lista.dodaj(k);

      // Prikazivanje elemenata liste
      System.out.println("Sadraj liste:");
      System.out.println(lista);
      System.out.println("Duina liste: " + lista.duina());

      // Traenje elementa u listi
      k = 23;
      System.out.println();
      System.out.print("Element " + k + " se ");
      if (lista.nai(k) == false)
         System.out.print("ne ");
      System.out.println("nalazi u listi");
   }
}

class PovezanaLista {

   private ElementListe prvi;   // prvi element liste
   private ElementListe posl;   // poslednji element liste
   private int n;               // broj elemenata liste

   // Konstruktor za formiranje prazne liste
   public PovezanaLista() {
      prvi = null;
      posl = null;
      n = 0;
   }

   // Duina liste
   public int duina() {
      return n;
   }

   // Ispitivanje da li je lista prazna
   public boolean praznaLista() {
      return prvi == null;
   }

   // Dodavanje elementa na kraj liste
   public void dodaj(int k) {

      // Konstruisati novi element liste
      ElementListe noviElem = new ElementListe(k);

      if (praznaLista())
         prvi = posl = noviElem;
      else {
         posl.setSled(noviElem);
         posl = noviElem;
      }
      n++;
   }

   // Ispitivanje da li je dati element u listi
   public boolean nai(int k) {

      ElementListe elem;
      for (elem = prvi; elem != null; elem = elem.getSled()) {
         if (elem.getKlju() == k)
            break;
      }
      return (elem != null);
   }

   // String reprezentacija povezane liste
   public String toString() {

      String s = "";
      for (ElementListe elem = prvi; elem != posl; elem = elem.getSled()) {
         s = s + elem.getKlju() + ", ";
      }
      if (posl != null)
         s = s + posl.getKlju();
      return s;
   }
}

class ElementListe {

   private int klju;         // sadraj elementa liste
   private ElementListe sled; // pokaziva na sledei element liste

   // Konstruktor
   public ElementListe(int k) {
      klju = k;
      sled = null;
   }

   // Pristup poljima elementa liste
   public void setSled(ElementListe elem) {
      sled = elem;
   }

   public ElementListe getSled() {
      return sled;
   }

   public int getKlju() {
      return klju;
   }
}