// ,,Klijentska klasa'' za testiranje
public class TestStekLista {

   public static void main(String[] args) {

      // Konstruisanje novog (praznog) steka
      StekLista s = new StekLista();
      System.out.println("Sadraj steka: " + s);
      System.out.println("Veliina steka: " + s.duina());
      System.out.println();

      // Dodavanje nekih elemenata na stek
      int k = 17;
      s.push(k);
      s.push(23); s.push(31); s.push(47);
      s.push(22); s.push(11);
      System.out.println("Sadraj steka: " + s);
      System.out.println("Veliina steka: " + s.duina());
      System.out.println();

      // Uklanjanje nekih elemenata sa steka
      if (!s.prazanStek())
         System.out.println("Uklonjen element: " + s.pop());
      if (!s.prazanStek())
         System.out.println("Uklonjen element: " + s.pop());
      System.out.println("Sadraj steka: " + s);
      System.out.println("Veliina steka: " + s.duina());
      System.out.println();

      // Uzimanje vrednosti elementa na vrhu steka
      if (!s.prazanStek())
         System.out.println("Element na vrhu: " + s.peek());
      System.out.println("Veliina steka: " + s.duina());
      System.out.println();

      // Jo malo dodavanja i uklanjanja elemenata ...
      s.push(69);
      s.pop(); s.pop(); s.peek();
      System.out.println("Sadraj steka: " + s);
      System.out.println("Veliina steka: " + s.duina());
      System.out.println();
   }
}

class StekLista {

   private ElementSteka vrh;   // vrh steka
   private int n;              // broj elemenata steka

   // Konstruktor za formiranje praznog steka
   public StekLista() {
      vrh = null;
      n = 0;
   }

   // Duina steka
   public int duina() {
      return n;
   }

   // Ispitivanje da li je stek prazan
   public boolean prazanStek() {
      return vrh == null;
   }

   // Dodavanje elementa na vrh steka
   public void push(int k) {

      // Konstruisati novi element steka
      ElementSteka noviElem = new ElementSteka(k);

      if (prazanStek())
         vrh = noviElem;
      else {
         noviElem.setSled(vrh);
         vrh = noviElem;
      }
      n++;
   }

   // Uklanjanje elementa sa vrha steka
   public int pop() {

      // Podrazumeva se da stek nije prazan
      ElementSteka elem = vrh;
      vrh = elem.getSled();
      n--;
      return elem.getKlju();
   }

   // Vraanje vrednosti elementa na vrhu steka
   public int peek() {

      // Podrazumeva se da stek nije prazan
      return vrh.getKlju();
   }

   // String reprezentacija steka
   public String toString() {

      String s = "";
      ElementSteka elem = vrh;
      while (elem != null) {
         s = s + elem.getKlju();
         elem = elem.getSled();
         if (elem != null)
            s = s + ", ";
      }
      return s;
   }
}

class ElementSteka {

   private int klju;         // sadraj elementa steka
   private ElementSteka sled; // pokaziva na sledei element steka

   // Konstruktor
   public ElementSteka(int k) {
      klju = k;
      sled = null;
   }

   // Pristup poljima elementa steka
   public void setSled(ElementSteka elem) {
      sled = elem;
   }

   public ElementSteka getSled() {
      return sled;
   }

   public int getKlju() {
      return klju;
   }
}